@ECHO OFF
SET source_dir=L:\Tools\EUMETCast\received\Sentinel-3A-EFR
SET proc_dir=F:\Sentinel\3A\Process
SET untar=C:\Tools\7-zip\7z
ECHO Processing files in %source_dir%
  FOR /F %%G in ('dir /B %source_dir%\*EFR____20*.SEN3.tar') DO (
  CALL :MakeImage %%G
)

GOTO :EOF

REM ==================================
REM    Main processing subroutine
REM ==================================

:MakeImage
ECHO Processing %1
SET source=%1
SET yyyy=%source:~16,4%
SET mm=%source:~20,2%
SET dd=%source:~22,2%
SET hh=%source:~25,2%
SET nn=%source:~27,2%
SET ss=%source:~29,2%
SET pass=%source:~0,-4%

TITLE Processing Sentinel data from %yyyy%-%mm%-%dd% at %hh%:%nn%
SET image_dir=F:\Sentinel\3A\Images\%yyyy%\%mm%\%dd%
IF NOT EXIST %image_dir% MKDIR %image_dir%
SET jpg_image=%image_dir%\%yyyy%-%mm%-%dd%-%hh%%nn%-%ss%-S3A-r9g6b4.jpg

IF EXIST %jpg_image% (
  @ECHO Image already processed %jpg_image%
  GOTO :EOF
)

IF NOT EXIST %proc_dir%\%pass% (
  @ECHO Unpacking TAR to indivdual files
  %untar% x -aoa %source_dir%\%source% -o%proc_dir% *Oa09* *Oa06* *Oa04* -r
)

SET tif_image=%image_dir%\%yyyy%-%mm%-%dd%-%hh%%nn%-%ss%-S3A-r9g6b4.tif
SET png_image=%image_dir%\%yyyy%-%mm%-%dd%-%hh%%nn%-%ss%-S3A-r9g6b4.png
@ECHO Converting files to PNG image
D:\Tools\Anaconda3\python.exe  C:\Tools\Admin\ProcessSentinel.py  %proc_dir%\%pass%  %png_image%  PNG

ECHO Converting PNG to JPG
PUSHD C:\Tools\ImageMagick-7.0.3-Q16
magick.exe convert %png_image% -equalize -sharpen 0.7 %jpg_image%
POPD

IF EXIST %jpg_image% (
  DEL /Q %proc_dir%\%pass%\*.* 
  RMDIR /S /Q %proc_dir%\%pass%
)

ECHO Processed Sentinel data from %yyyy%-%mm%-%dd% %hh%:%nn%, processed on %DATE% at %TIME% > C:\Tools\Admin\ProcessSentinel.log
GOTO :EOF
